<?php

namespace App\Modules\Action;

use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Container\ContainerInterface;
use App\Modules\Ldap\Ldap;

class Action
{

    public $ldap;
    public $conn;
    
    public function __construct(ContainerInterface $container)
    {
        $this->ldap = $container->get('settings')['ldap'];
	$this->conn = new Ldap($this->ldap);
    }

    public function select(ServerRequestInterface $request,
			   ResponseInterface $response, $args): ResponseInterface
    {
	$body = json_decode($request->getBody(), true);
	$username = $body['select'];
	$user = $this->conn->get_user($username);
	$d = $this->conn->search_depart_by_member($username);
	if ($body['check']) {
	    if (isset($body['name'])){
		$_SESSION['select'][$body['select']] = $d[0]['name'];
	    } else {
		$_SESSION['select'][$body['select']] = "ok";
	    }
	} else {
	    unset($_SESSION['select'][$body['select']]);
	}
	$response->getBody()->write(json_encode($_SESSION));
	return $response;
    }

}
