<?php

namespace App\Modules\Config;

use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Container\ContainerInterface;
use Slim\Views\Twig;
use App\Modules\FSAPI\FSAPI;
use App\View\Pages;

class Config extends Pages
{

    private $config;
    private $path;
    private $rest;
    private $call_status;
    
    public function __construct(ContainerInterface $container)
    {
	$this->config = $container->get('settings');
	$this->path = "/persist/etc/casper";
	$this->rest = $container->get('settings')['rest'];
	$this->call_status = $container->get('settings')['call_status'];
    }

    public function get(ServerRequestInterface $request,
			ResponseInterface $response, array $args): ResponseInterface
    {
	session_start();
	$view = Twig::fromRequest($request);
	$api = new FSAPI($this->rest);
	$config = $api->config();
	return $this->render($request, $response, 'config.html', [
	    'data' => $this->config,
	    'config' => $config
	]);
    }

    public function save(ServerRequestInterface $request,
			 ResponseInterface $response, array $args): ResponseInterface
    {
	$params = $request->getParsedBody();
	$view = Twig::fromRequest($request);
	if(isset($params['local_config'])){
	    $config_file = fopen("$this->path/config.php", "w") or die("Unable to open file!");
	    fwrite($config_file, "<?php\n");
	    $params = $request->getParsedBody();
	    fwrite($config_file, '$'."config['ldap']['host'] = \"" . $params['host']. "\";\n");
	    fwrite($config_file, '$'."config['ldap']['rdn'] = \"" . $params['rdn'] . "\";\n");
	    fwrite($config_file, '$'."config['ldap']['pass'] = \"" . $params['pass'] . "\";\n");
	    fwrite($config_file, '$'."config['ldap']['base'] = \"" . $params['base'] . "\";\n");
	    fwrite($config_file, '$'."config['media']['folder'] = \"" . $params['folder'] . "\";\n");
	    fwrite($config_file, '$'."config['rest']['server'] = \"" . $params['server'] . "\";\n");
	    fwrite($config_file, '$'."config['defaults']['parallel'] = \"" . $params['parallel'] . "\";\n");
	    fwrite($config_file, '$'."config['defaults']['repeate'] = \"" . $params['repeate'] . "\";\n");
	    fwrite($config_file, '$'."config['defaults']['wait'] = \"" . $params['wait'] . "\";\n");
	    fwrite($config_file, '$'."config['defaults']['number_from'] = \"" . $params['number_from'] . "\";\n");
	    fwrite($config_file, '$'."config['defaults']['number_record'] = \"" . $params['number_record'] . "\";\n");
	    fwrite($config_file, '$'."config['defaults']['phrase'] = \"" . $params['phrase'] . "\";\n");
	    
	    foreach($this->call_status as $code => $status){
		fwrite($config_file, '$'."config['call_status']['$code'] = \""
				   . $status . "\";\n");
	    }
	    $data['ldap']['host'] = $params['host'];
	    $data['ldap']['rdn'] = $params['rdn'];
	    $data['ldap']['pass'] = $params['pass'];
	    $data['ldap']['base'] = $params['base'];

	    $data['media']['folder'] = $params['folder'];

	    $data['rest']['server'] = $params['server'];

	    fclose($config_file);
	} elseif (isset($params['fsapi_config'])){
	    $api = new FSAPI($this->rest);
	    $data['media_folder'] = $params['media_folder'];
	    $data['host_in'] = $params['host_in'];
	    $data['port_in'] = $params['port_in'];
	    $data['pass'] = $params['pass'];
	    $data['port'] = $params['port'];
	    $data['host'] = $params['host'];
	    $data['gw'] = $params['gw'];
	    $data['pattern'] = $params['pattern'];
	    
	    $config = $api->set_config($data);
	}
	return $response->withStatus(302)->withHeader('Location', '/ui/config');
	/* return $view->render($response, 'config.html', [
	   'data' => $data
	   ]); */
    }

    public function call_status(ServerRequestInterface $request,
				ResponseInterface $response, array $args): ResponseInterface
    
    {
	$params = $request->getParsedBody();
	$config_file = fopen("$this->path/config.php", "w") or die("Unable to open file!");
	fwrite($config_file, "<?php\n");
	fwrite($config_file, '$'."config['ldap']['host'] = \"" . $this->config['ldap']['host']. "\";\n");
	fwrite($config_file, '$'."config['ldap']['rdn'] = \"" . $this->config['ldap']['rdn'] . "\";\n");
	fwrite($config_file, '$'."config['ldap']['pass'] = \"" . $this->config['ldap']['pass'] . "\";\n");
	fwrite($config_file, '$'."config['ldap']['base'] = \"" . $this->config['ldap']['base'] . "\";\n");
	fwrite($config_file, '$'."config['media']['folder'] = \"" . $this->config['media']['folder']
			   . "\";\n");
	fwrite($config_file, '$'."config['rest']['server'] = \"" . $this->config['rest']['server']
			   . "\";\n");
	fwrite($config_file, '$'."config['defaults']['parallel'] = \"" . $this->config['defaults']['parallel']
			   . "\";\n");
	fwrite($config_file, '$'."config['defaults']['repeate'] = \""
			   . $this->config['defaults']['repeate'] . "\";\n");
	fwrite($config_file, '$'."config['defaults']['wait'] = \""
			   . $this->config['defaults']['wait'] . "\";\n");
	fwrite($config_file, '$'."config['defaults']['number_from'] = \""
			   . $this->config['defaults']['number_from'] . "\";\n");
	fwrite($config_file, '$'."config['defaults']['number_record'] = \""
			   . $this->config['defaults']['number_record'] . "\";\n");
	fwrite($config_file, '$'."config['defaults']['phrase'] = \""
			   . $this->config['defaults']['phrase'] . "\";\n");

	unset($params['key']);
	unset($params['value']);
	unset($params['call_status']);
	foreach($params as $code => $status){
	    fwrite($config_file, '$'."config['call_status']['$code'] = \""
			       . $status . "\";\n");
	}
	
	fclose($config_file);
	echo var_dump($params);
	return $response->withStatus(302)->withHeader('Location', '/ui/config');
    }
}
