<?php

namespace App\Modules\Main;

use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Container\ContainerInterface;
use Psr\Http\Message\UploadedFileInterface;
use Slim\Views\Twig;
use App\Modules\FSAPI\FSAPI;
use App\View\Pages;
use App\Model\UpdateImage;
use App\Model\SystemImage;

class Main extends Pages
{
    private $rest;
    
    public function __construct(ContainerInterface $container)
    {
	$this->rest = $container->get('settings')['rest'];
    }

    public function main(ServerRequestInterface $request,
			 ResponseInterface $response, array $args): ResponseInterface
    {
	/* $view = Twig::fromRequest($request); */
	/* $view = new Pages($request); */
	$api = new FSAPI($this->rest);
	$status = $api->status();
	$session = $api->session();
	/* echo var_dump($_SESSION); */
	date_default_timezone_set("Europe/Minsk");
	$date = date("H:i:s d.m.Y");
	/* return $view->render($response, "index.html",
	   ['status' => $status,
	   'session' => $session,
	   'user' => $_SESSION['user'],
	   'current_date' => $date]); */
	/* echo var_dump($_SESSION); */
	return $this->render($request, $response, "index.html",
			     /* ['status' => $status,
				'session' => $session,
				'user' => $_SESSION['user'],
				'current_date' => $date] */
			     $status);
	/* return $view->bad($request); */

    }

    public function system(ServerRequestInterface $request,
			   ResponseInterface $response, array $args): ResponseInterface
    {

        $body = json_decode($request->getBody(), true);
        $cmd = $args['cmd'];
        $data['cmd'] = $body['cmd'];
        $data['args'] = $body['args'];
	if ($data['cmd'] == "set_date"){
	    $time = $data['args'];
	    $res = shell_exec("sudo /var/www/cgi/update_time 2>&1 ". $data['args']);
	    echo var_dump($res);
 	} else {
	    $api = new FSAPI($this->rest);
            $result = $api->system($data);
	}
        return $response;
        // return $response->withStatus(302)
        //     ->withHeader('Location', "/ui/user/$name");
    }

    public function current_state(ServerRequestInterface $request,
				  ResponseInterface $response, array $args): ResponseInterface
    {
	/* $view = Twig::fromRequest($request); */
	$api = new FSAPI($this->rest);
	$status = $api->status();
	$session = $api->session();
	/* echo var_dump($status); */
	date_default_timezone_set("Europe/Minsk");
	$date = date("H:i:s d.m.Y");
	return $this->render($request, $response, "state.html",
			     ['status' => $status,
			      'session' => $session,
			      'current_date' => $date]);
    }

    public function update(ServerRequestInterface $request,
			   ResponseInterface $response, array $args): ResponseInterface
    {
	/* $rauc_status = shell_exec('rauc status --detailed --output-format=json');
	   $status = json_decode($rauc_status, true); */
	/* echo var_dump($status); */
	$status = new SystemImage();
	$params = $request->getQueryParams();
	$update = [];
	if (isset($params['filename'])){
	    $filename = $params['filename'];
	    /* $update = json_decode(shell_exec("rauc --output-format=json info $filename"), true); */
	    $update = new UpdateImage($filename);
	}
	/* echo var_dump($status); */
	$update_files = glob("/tmp/*.rauc");
	/* $output = shell_exec('rauc --output-format=json info /tmp/mc03-media-12.rauc'); */
	return $this->render($request, $response, 'update.html', [
	    'status' => $status,
	    'update_files' => $update_files,
	    'update' => $update,
	    'filename' => $filename
	]);
    }

    public function load_image(ServerRequestInterface $request,
			       ResponseInterface $response, array $args): ResponseInterface
    {
	$directory = "/tmp";
	$uploadedFiles = $request->getUploadedFiles();
	echo var_dump($uploadedFiles);
	// handle single input with single file upload
	$uploadedFile = $uploadedFiles['update'];
	$error = $uploadedFile->getError();
	if ($error == UPLOAD_ERR_OK) {
	    echo "upload file OK";
	    $filename = $this->moveUploadedFile($directory, $uploadedFile);
	    echo $filename;
	    /* $response->getBody()->write('Uploaded: ' . $filename . '<br/>'); */
	} else {
	    echo "upload file ERROR";
	    echo var_dump($error);
	}
	$status = shell_exec('rauc status --detailed --output-format=json');
	/* $update = json_decode(
	   shell_exec("rauc --output-format=json info $directory/$filename"), true); */
	$update = new UpdateImage("$directory/$filename");
	return $response->withStatus(302)
			->withHeader('Location', "/ui/update");
    }

    public function update_image(ServerRequestInterface $request,
				 ResponseInterface $response, array $args): ResponseInterface
    {
	$params = $request->getParsedBody();
	if (isset($params['file'])){
	    $resp = shell_exec("sudo /var/www/cgi/update_release 2>&1 ".$params['file']);
	    $status = shell_exec('rauc status --detailed --output-format=json');
	    $status = json_decode($status, true);
	    return $this->render($request, $response, 'update_complete.html', [
		'resp' => $resp,
		'status' => $status
	    ]);
	} else {
	    return $response->withStatus(302)
			    ->withHeader('Location', "/ui/update");
	}
    }

    private function moveUploadedFile(string $directory, UploadedFileInterface $uploadedFile)
    {
	$filename = $uploadedFile->getClientFilename();
	//$extension = pathinfo($uploadedFile->getClientFilename(), PATHINFO_EXTENSION);

	// see http://php.net/manual/en/function.random-bytes.php
	//$basename = bin2hex(random_bytes(8));
	//$filename = sprintf('%s.%0.8s', $basename, $extension);

	$uploadedFile->moveTo($directory . DIRECTORY_SEPARATOR . $filename);

	return $filename;
    }

}
