<?php

namespace App\Modules\Media;

use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Container\ContainerInterface;
use Slim\Views\Twig;
use App\Modules\FSAPI\FSAPI;
use App\View\Pages;

class Media extends Pages
{
    private $rest;
    private $folder;
    private $defaults;
    
    public function __construct(ContainerInterface $container)
    {
	$this->rest = $container->get('settings')['rest'];
	$this->folder = $container->get('settings')['media']['folder'];
	$this->defaults = $container->get('settings')['defaults'];
    }

    public function get(ServerRequestInterface $request,
			ResponseInterface $response, array $args): ResponseInterface
    {
	session_start();
	$view = Twig::fromRequest($request);
	$files =  glob("$this->folder/*.wav");
	$media = [];
	foreach ($files as $file){
	    $media[] = basename($file);
	}
	return $this->render($request, $response, "media.html",
			     ['files' => $media,
			      'defaults' => $this->defaults]);
	/* return $view->render($response, "media.html",
	   ['files' => $media,
	   'defaults' => $this->defaults]); */
    }

    public function del(ServerRequestInterface $request,
			ResponseInterface $response, array $args): ResponseInterface
    {
	$name = $args['name'];
	$files =  unlink("$this->folder/$name");
	$response->getBody()->write("ok");
    }


    public function upload(ServerRequestInterface $request,
			   ResponseInterface $response, array $args): ResponseInterface
    {
	$directory = "$this->folder/";
	$uploadedFiles = $request->getUploadedFiles();
	/* echo var_dump($uploadedFiles); */
	// handle single input with single file upload
	$uploadedFile = $uploadedFiles['media'];
	$error = $uploadedFile->getError();
	if ($error == UPLOAD_ERR_OK) {
	    echo "upload file OK";
	    $filename = $uploadedFile->getClientFilename();
	    // $filename = moveUploadedFile($directory, $uploadedFile);
	    $uploadedFile->moveTo($directory . DIRECTORY_SEPARATOR . $filename);
	    echo $filename;
	    /* $response->getBody()->write('Uploaded: ' . $filename . '<br/>'); */
	} else {
	    echo "upload file ERROR";
	    echo var_dump($error);
	}
	return $response->withStatus(302)
			->withHeader('Location', "/ui/media");

    }

    public function record(ServerRequestInterface $request,
			   ResponseInterface $response, array $args): ResponseInterface
    {
	$params = $request->getParsedBody();
	$fn = $params['file_name'];
	$words = explode(' ', $fn);
	$fn  = implode('_', $words);
	$fn = $fn.".wav";
	$number = $params['number'];
	$api = new FSAPI($this->rest);
	$from = $this->defaults['number_from'];
	$current_session = $api->record($fn, $number, $from);

	$files =  glob("$this->folder/*.wav");
	$media = [];
	foreach ($files as $file){
	    $media[] = basename($file);
	}
	return $response->withStatus(302)->withHeader('Location', '/ui/media');
	/* return $view->render($response, "media.html",
	   ['files' => $media,
	   'session' => $session]); */
	
    }

    public function express(ServerRequestInterface $request,
			    ResponseInterface $response, array $args): ResponseInterface
    {
	$params = $request->getQueryParams();
	$fn = $params['file_name'];
	$from = $this->defaults['number_from'];
	$number = $this->defaults['number_record'];
	$api = new FSAPI($this->rest);
	$current_session = $api->record($fn, $number, $from);
	$response->getBody()->write("ok");
	return $response;
	
    }
}
