<?php

namespace App\Modules\Phrase;

use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Container\ContainerInterface;
use Slim\Views\Twig;
use App\View\Pages;

class Phrase extends Pages
{
    private $filename;
    
    public function __construct(ContainerInterface $container)
    {
	$this->filename = $container->get('settings')['defaults']['phrase'];
    }
    public function get_phrase(ServerRequestInterface $request,
			       ResponseInterface $response, array $args): ResponseInterface
    {
	/* $view = Twig::fromRequest($request); */
	$actions = [];

	if(($fp = fopen($this->filename, 'r')) !== FALSE){
	    while (($data = fgetcsv($fp, 100, ",")) !== FALSE) {
		$actions[] = ['action' => $data[0],
			      'data' => $data[1]];
	    }
	} else {
	    $actions[] = ['action' => 'play',
			  'data' => 'anonce'];
	};
	
	return $this->render($request, $response, 'phrase.html', [
	    'actions' => $actions
	]);
    }

    public function edit_phrase(ServerRequestInterface $request,
				ResponseInterface $response, array $args): ResponseInterface
    {
	$data = $request->getParsedBody();
	$phrase = [];
	for($i=0;$i < count($data['action']); $i++){
	    $phrase[] = ['action' => $data['action'][$i],
			 'data' => $data['data'][$i]];
	}

	$fp = fopen($this->filename, 'w');
	$temp = [];
	foreach ($phrase as $f) {
	    $el = [];
	    $el[] = $f['action'];
	    $el[] = $f['data'];
	    $temp[] = $el;
	    
	}
	foreach ($phrase as $fields) {
	    fputcsv($fp, $fields);
	}
	
	fclose($fp);
	$this->set_message("изменения успешно сохранены");
        return $this->render($request, $response, 'phrase.html', [
	    'actions' => $phrase
	]);
    }
    
}



