<?php

namespace App\Modules\User;

use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Container\ContainerInterface;
use Slim\Views\Twig;
use App\Modules\Ldap\Ldap;
use App\View\Pages;

class Group extends Pages
{
    private $ldap;
    private $conn;
    
    public function __construct(ContainerInterface $container)
    {
        $this->ldap = $container->get('settings')['ldap'];
	$this->conn = new Ldap($this->ldap);
    }

    public function get(ServerRequestInterface $request,
			ResponseInterface $response, array $args): ResponseInterface
    {
	session_start();
	/* $view = Twig::fromRequest($request); */
	$groups = $this->conn->search_groups('*');
	$session = [];
	if(isset($_SESSION['select'])){
            foreach ($_SESSION['select'] as $user => $val){
		$session[$val][] = $user;
            }
	}
	/* if ($groups != []){
	   $group = $this->conn->get_group($groups[0]['name']);
	   } */
	// echo var_dump($session);
	return $this->render($request, $response, 'groups.html', [
	    'data' => [],
	    'groups' => $groups,
	    'session' => $_SESSION,
            'sess_by_gr' => $session,
	    'currentPath' => $_SERVER['REQUEST_URI']
	]);
	
    }

    public function group(ServerRequestInterface $request,
			  ResponseInterface $response, array $args): ResponseInterface
    {
	/* $view = Twig::fromRequest($request); */
	session_start();
	$name = $args['name'];
	$group = $this->conn->get_group($name);
	$groups = $this->conn->search_groups("*");

	$sesison = [];
	foreach ($_SESSION['select'] as $user => $val){
	    $session[$val][] = $user;
	}
	$params = $request->getQueryParams();
	if (isset($params['query']) AND $params['query']!=''){
	    $query = $params['query'];
	    $info = $this->conn->search_with_group_without_list($query, $name);
	} else {
	    $query = '*';
	    $info = [];
	}

	/* echo var_dump($info); */
	return $this->render($request, $response, 'groups.html', [
	    'data' => $group,
	    'name' => $name,
	    'groups' => $groups,
	    'search' => $info,
	    'session' => $_SESSION,
            'sess_by_gr' => $session,
	    'currentPath' => $_SERVER['REQUEST_URI'],
	    'query' => $query
	]);
    }

    public function new(ServerRequestInterface $request,
			ResponseInterface $response, array $args): ResponseInterface
    {
        session_start();
        $view = Twig::fromRequest($request);
        $params = $request->getParsedBody();

        $name = $params['group_name'];
        $prio = $params['group_prio'];

        $data['name'] = $name;
        if($prio){
            $data['prio'] = $prio;
        }
        $insert = $this->conn->create_list($data);
	
        $groups = $this->conn->search_groups('*');
        return $response->withStatus(302)
			->withHeader('Location', "/ui/group/$name");
    }

    public function add_to_list(ServerRequestInterface $request,
				ResponseInterface $response, array $args): ResponseInterface
    {
	$list_name = $args['name'];
	$body = json_decode($request->getBody(), true);

	if (isset($body['cmd']) & $body['cmd'] == 'del'){
            $res = $this->conn->del_from_list($list_name, $body['name']);
	} else {
            $res = $this->conn->add_to_list($list_name, $body['name']);}
	
	if($res){
	    $response->getBody()->write("ok");
	} else {
	    $response->getBody()->write("error");
	}
	
	return $response;

    }

    public function list_modify(ServerRequestInterface $request,
				ResponseInterface $response, array $args): ResponseInterface
    {
        $params = json_decode($request->getBody(), true);
        $list_name = $params['name'];
        $prio = $params['weidth'];
        $res = $this->conn->modify_list($list_name, $prio);

        $response->getBody()->write("ok");
        return $response;
    }

    public function del_list(ServerRequestInterface $request,
			     ResponseInterface $response, array $args): ResponseInterface
    {
        $name = $args['name'];
        $res = $this->conn->del_list($name);

        $response->getBody()->write("ok");
        return $response;
    }
}
